import * as React from 'react';
import { CommonProps } from './common-prop-types';
declare type ControlProps = React.TextareaHTMLAttributes<HTMLTextAreaElement>;
declare type ControlPropsCleaned = Omit<ControlProps, 'id' | 'name'>;
interface TextareaControlProps extends CommonProps, ControlPropsCleaned {
    cols: number;
    rows: number;
    value: string;
    elementRef: React.RefObject<HTMLTextAreaElement>;
}
declare class TextareaControl extends React.Component<TextareaControlProps, {}> {
    static defaultProps: {
        cols: number;
        rows: number;
        value: string;
        elementRef: React.RefObject<HTMLTextAreaElement>;
    };
    constructor(props: any);
    render(): JSX.Element;
}
export { TextareaControlProps };
export default TextareaControl;
