import * as React from 'react';
import { Props as SelectControlProps } from './controls/select';
interface SelectOption {
    value: string;
    label: string;
    disabled?: boolean;
    className?: string;
    group?: string;
}
declare const defaultProps: {
    options: SelectOption[];
    multiple: boolean;
    elementRef: React.RefObject<HTMLSelectElement>;
    changeCallback: (name: string, value: import("../types").ComponentValue) => void;
    elementWrapperClassName: import("classnames/types").ClassValue;
    errorMessages: React.ReactNode[];
    help: string;
    id: string;
    isPristine: boolean;
    label: React.ReactNode;
    labelClassName: import("classnames/types").ClassValue;
    layout: import("../types").LayoutType;
    onSetValue: (value: import("../types").ComponentValue) => void;
    rowClassName: import("classnames/types").ClassValue;
    showErrors: boolean;
};
declare type SelectProps = SelectControlProps & typeof defaultProps;
declare class Select extends React.Component<SelectProps, {}> {
    static defaultProps: {
        options: SelectOption[];
        multiple: boolean;
        elementRef: React.RefObject<HTMLSelectElement>;
        changeCallback: (name: string, value: import("../types").ComponentValue) => void;
        elementWrapperClassName: import("classnames/types").ClassValue;
        errorMessages: React.ReactNode[];
        help: string;
        id: string;
        isPristine: boolean;
        label: React.ReactNode;
        labelClassName: import("classnames/types").ClassValue;
        layout: import("../types").LayoutType;
        onSetValue: (value: import("../types").ComponentValue) => void;
        rowClassName: import("classnames/types").ClassValue;
        showErrors: boolean;
    };
    constructor(props: any);
    private handleChange;
    render(): JSX.Element;
}
export { SelectProps };
export default Select;
