var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import classNames from 'classnames/dedupe';
import { componentDefaultProps } from './component-common';
import ErrorMessages from './error-messages';
import Help from './help';
import Row from './row';
import SelectControl from './controls/select';
var defaultProps = __assign(__assign({}, componentDefaultProps), { options: [], multiple: false, elementRef: React.createRef() });
var Select = /** @class */ (function (_super) {
    __extends(Select, _super);
    // Need to supply a constructor to be recognised as ComponentClass?
    function Select(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (event) {
            var target = event.currentTarget;
            var _a = _this.props, multiple = _a.multiple, onSetValue = _a.onSetValue, changeCallback = _a.changeCallback, name = _a.name;
            var value;
            if (multiple) {
                value = Array.from(target.options)
                    .filter(function (option) { return option.selected; })
                    .map(function (option) { return option.value; });
            }
            else {
                (value = target.value);
            }
            onSetValue(value);
            changeCallback(name, value);
        };
        return _this;
    }
    Select.prototype.render = function () {
        var _a = this.props, className = _a.className, errorMessages = _a.errorMessages, help = _a.help, id = _a.id, layout = _a.layout, name = _a.name, required = _a.required, showErrors = _a.showErrors, inputProps = __rest(_a, ["className", "errorMessages", "help", "id", "layout", "name", "required", "showErrors"]);
        Object.keys(componentDefaultProps).forEach(function (key) {
            delete inputProps[key];
        });
        var markAsInvalid = showErrors && (errorMessages.length > 0 || required);
        var control = (React.createElement(SelectControl, __assign({}, inputProps, { className: classNames(markAsInvalid ? ['is-invalid', className] : className), elementRef: this.props.elementRef, id: id, name: name, onChange: this.handleChange })));
        if (layout === 'elementOnly') {
            return control;
        }
        return (React.createElement(Row, __assign({}, this.props, { htmlFor: id }),
            React.createElement(React.Fragment, null,
                control,
                help ? React.createElement(Help, { help: help }) : null,
                showErrors ? React.createElement(ErrorMessages, { messages: errorMessages }) : null)));
    };
    Select.defaultProps = defaultProps;
    return Select;
}(React.Component));
export default Select;
//# sourceMappingURL=select.js.map