export default (function (fn, time) {
    var pending;
    var lastArgs;
    var lastThis;
    var cancel = function () {
        clearTimeout(pending);
        pending = undefined;
    };
    var run = function () {
        if (lastArgs) {
            var currentThis = lastThis;
            var currentArgs = lastArgs;
            lastThis = undefined;
            lastArgs = undefined;
            fn.apply(currentThis, currentArgs);
        }
    };
    var flush = function () {
        cancel();
        run();
    };
    function debounced() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        lastThis = this;
        lastArgs = args;
        if (pending) {
            clearTimeout(pending);
        }
        pending = setTimeout(run, time);
    }
    debounced.cancel = cancel;
    debounced.flush = flush;
    return debounced;
});
//# sourceMappingURL=debounce.js.map